<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Trade.php
//      Trade Centre stuff (trade listing, etc.)
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: Shop-Trade.php 24 2006-10-21 03:34:18Z daniel15 $

// If this script isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

// Visiting the trade centre
if ($_GET['do'] == "trade") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=trade",
		'name' => $txt['shop_trade'],
	);
	
	// Get the current user's money count
	$result = db_query("SELECT money
				FROM {$db_prefix}members
				WHERE ID_MEMBER = $ID_MEMBER
				LIMIT 1", __FILE__, __LINE__);
	
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$usersmoney = $row['money'];
	
	$context['shop_trade_list'] = "";
	$alternating = "windowbg2";
	
	// Get all the items in the trade centre
	$result = db_query("SELECT it.name, it.desc, it.image, inv.id, m.realName, inv.tradecost
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it,
							 {$db_prefix}members AS m
						WHERE inv.trading = 1 AND inv.itemid = it.id AND 
							  m.ID_MEMBER = inv.ownerid",
						__FILE__, __LINE__);
	// Loop through all items
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		
		// Add the item to the list
		$context['shop_trade_list'] .= "
			<tr valign='top' class='{$alternating}'>
				<td>
					<img border='0' width='32' height='32' src='{$boardurl}/Sources/shop/item_images/{$row['image']}' alt='Item Image' />
				</td>
				<td style='padding-bottom: 2ex;' width='20%'>
					{$row['name']}
				</td>
				<td>
					{$row['desc']}<br />
					<i>".sprintf($txt['shop_trade_saleby'], $row['realName'])."</i>
				</td>
				<td width='18%'>
					{$txt['shop_price']}: {$row['tradecost']}<br />";
	
		// If the user has enough money to buy it
		if ($usersmoney >= $row['tradecost']) {
			// Show the 'Buy now' link
			$context['shop_trade_list'] .= "<a href='$scripturl?action=shop;do=trade_buy;id={$row['id']}'>{$txt['shop_buynow']}</a>";
		// Otherwise
		} else {
			// They can't afford it - Tell them to start saving their money :)
			$context['shop_trade_list'] .= "<b>".sprintf($txt['shop_need'], formatMoney($row['tradecost'] - $usersmoney))."</b>";
		}

		// Close the table row
		$context['shop_trade_list'] .= "</td></tr>";

		$alternating = ($alternating == "windowbg") ? "windowbg2" : "windowbg";
	}
	
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_trade'];
	// Use the trade centre sub template
	$context['sub_template'] = "userTrade";
	loadTemplate('Shop');
	
// If they're buying an item from the trade centre
} elseif ($_GET['do'] == "trade_buy") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=trade",
		'name' => $txt['shop_trade'],
	);

	// Current user's details
	$result = db_query("SELECT money, realName, memberName
						FROM {$db_prefix}members
						WHERE ID_MEMBER = {$ID_MEMBER}
						LIMIT 1", __FILE__, __LINE__);
	
	$row_user = mysql_fetch_array($result, MYSQL_ASSOC);

	// Make sure item ID was numeric
	$_GET['id'] = (int) $_GET['id'];
					
	// Get information on the item in question	
	$result = db_query("SELECT it.name, inv.tradecost, inv.trading, inv.ownerid, m.realName,
							   m.emailAddress
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it,
							 {$db_prefix}members AS m
						WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
						LIMIT 1", __FILE__, __LINE__);
						
	$row_item = mysql_fetch_array($result, MYSQL_ASSOC);
	
	// If this item is not for trade
	if ($row_item['trading'] != 1) {
		$context['shop_buy_message'] = $txt['shop_no_sale'];
	// If they can't afford it
	} elseif ($row_user['money'] < $row_item['tradecost']) {
		$context['shop_buy_message'] = sprintf($txt['shop_not_enough_money'], $cost - $usersmoney);
	} else {
		// Change item info (owner, amount paid, trading = not anymore)
		$result = db_query("UPDATE {$db_prefix}shop_inventory
							SET ownerid = {$ID_MEMBER}, amtpaid = {$row_item['tradecost']},
								trading = 0
							WHERE id = {$_GET['id']}
							LIMIT 1", __FILE__, __LINE__);
							
		// Decrease user's money
		$result = db_query("UPDATE {$db_prefix}members
							SET money = money - {$row_item['tradecost']}
							WHERE ID_MEMBER = {$ID_MEMBER}
							LIMIT 1", __FILE__, __LINE__);
							
		// Give money to old owner
		$result = db_query("UPDATE {$db_prefix}members
							SET money = money + {$row_item['tradecost']}
							WHERE ID_MEMBER = {$row_item['ownerid']}
							LIMIT 1", __FILE__, __LINE__);			
		 
		// Who is sending the IM
		$pmfrom = array(
			'id' => $ID_MEMBER,
			'name' => $row_user['realName'],
			'username' => $row_user['memberName']
		);

		// Who is receiving the IM		
		$pmto = array(
			'to' => array($row_item['ownerid']),
			'bcc' => array()
		);
		// The message subject
		$subject = sprintf($txt['shop_im_trade_subject'], $row_item['name']);
		// The actual message
		$message = sprintf($txt['shop_im_trade_message'], $ID_MEMBER, $row_user['realName'], $row_item['name'], formatMoney($row_item['tradecost']));
		// Send the PM
		sendpm($pmto, $subject, $message, 0, $pmfrom);
			
		$context['shop_buy_message'] = sprintf($txt['shop_trade_bought_item'], $row_item['name'], $row_item['realName']);
	}

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_trade'];	
	// Use the message template
	$context['sub_template'] = "message";
	loadTemplate('Shop');

// If they're selling an item in the trade centre
} elseif ($_GET['do'] == "trade_sell") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);
	
	// Make sure ID was numeric
	$_GET['id'] = (int) $_GET['id'];
	// Get information on the item
	$result = db_query("SELECT amtpaid
						FROM {$db_prefix}shop_inventory
						WHERE id = {$_GET['id']}", __FILE__, __LINE__);
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	// The amount paid for the item
	$context['shop_paid'] = $row['amtpaid'];
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_yourinv'];
	// Use the trade item sub template
	$context['sub_template'] = "tradeItem";
	loadTemplate('Shop');
	
// Sell an item - Part 2. Actually add the item to the trade centre
} elseif ($_GET['do'] == "trade_sell2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);
	
	// Make sure certain values were numeric
	$_POST['id'] = (int) $_POST['id'];
	$_POST['sellfor'] = (int) $_POST['sellfor'];
	// Check the owner of the item
	$result = db_query("SELECT ownerid
						FROM {$db_prefix}shop_inventory
						WHERE id = {$_POST['id']}
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	// Sell it for a negative amount? That very odd...
	if ($_POST['sellfor'] <= 0) {
		$context['shop_buy_message'] = $txt['shop_trade_negative'];
	 // Sorry, stealing is illegal :P
	} elseif ($row['ownerid'] !== $ID_MEMBER) {
		$context['shop_buy_message'] = $txt['shop_use_others_item'];
	} else {
		// Update item's information
		$result = db_query("UPDATE {$db_prefix}shop_inventory
							SET trading = 1, 
								tradecost = {$_POST['sellfor']}
							WHERE id = {$_POST['id']}
							LIMIT 1", __FILE__, __LINE__);
		$context['shop_buy_message'] = $txt['shop_trade_success'];
	}
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_yourinv'];
	// Use the message template
	$context['sub_template'] = "message";
	loadTemplate('Shop');
	
// Stop trading an item
} elseif ($_GET['do'] == "trade_stop") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);
	
	// Make sure ID was numeric
	$_GET['id'] = (int) $_GET['id'];
	// Get the ownerID of the item
	$result = db_query("SELECT ownerid
						FROM {$db_prefix}shop_inventory
						WHERE id = {$_GET['id']}
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	// Sorry, people stealing aren't allowed here!
	if ($row['ownerid'] !== $ID_MEMBER) {
		$context['shop_buy_message'] = $txt['shop_use_others_item'];
	} else {
		// Cancel the trade centre stuff
		$result = db_query("UPDATE {$db_prefix}shop_inventory
							SET trading = 0, tradecost = 0
							WHERE id = {$_GET['id']}
							LIMIT 1", __FILE__, __LINE__);
		$context['shop_buy_message'] = $txt['shop_trade_cancelled'];
	}

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_yourinv'];
	// Use the message template
	$context['sub_template'] = "message";
	loadTemplate('Shop');
}
?>
