<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: ChangeDisplayName.php
//      Item

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: ChangeDisplayName.php 24 2006-10-21 03:34:18Z daniel15 $


class item_ChangeDisplayName extends itemTemplate {
    function getItemDetails() {
		$this->authorName = "Daniel15";
		$this->authorWeb = "http://www.dansoftaustralia.net/";
		$this->authorEmail = "dansoft@dansoftaustralia.net";

        $this->name = "Change Display Name";
        $this->desc = "Change your display name!";
        $this->price = 50;
    }

	function getAddInput() {
		return "Minimum length of name: <input type='text' name='info1' value='5' />";
	}

    function getUseInput() {
        return "New Display Name: <input type='text' name='newDisplayName' size='50' /><br />
                Please choose a name which is at least {$item_info[1]} characters long.";
    }

    function onUse() {
        global $db_prefix, $ID_MEMBER, $item_info;
		
		// Use a length of 5 as default
		if (!isset($item_info[1]) || $item_info[1] == 0) $item_info[1] = 5;

	if (strlen($_POST['newDisplayName']) < $item_info[1]) 
		die("ERROR: The name you chose was not long enough! Please go back and choose a name which is at least {$item_info[1]} characters long.");

        $result = db_query("UPDATE {$db_prefix}members
                            SET realName = '{$_POST['newDisplayName']}'
                            WHERE ID_MEMBER = {$ID_MEMBER}",
                            __FILE__, __LINE__);
        return "Successfully changed your display name to {$_POST['newDisplayName']}";
    }

}

?>
