<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: testitem.php
//      Test Item (requires NO input)

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: testitem.php 24 2006-10-21 03:34:18Z daniel15 $

// Your class should always be called item_filename, eg. if your file is 
// myCoolItem.php then the class should be called 'item_myCoolItem'. This 
// class should always extend itemTemplate.
class item_testitem extends itemTemplate {
	
	// When this function is called, you should set all the item's
	// variables (see inside this example)
	function getItemDetails() {

		// The author's name
		$this->authorName = "Daniel15";
		// The author's website
		$this->authorWeb = "http://www.dansoftaustralia.net/";
		// The author's email address
		$this->authorEmail = "dansoft@dansoftaustralia.net";

		//VALUES CHANGEABLE FROM WITHIN ADMIN PANEL:
		// The name of the item
		$this->name = "A Test Item";
		// The item's description
		$this->desc = "Just a test item!";
		// The item's price
		$this->price = 5;
		
		//UNCHANGEABLE VALUES:
		// Whether the item requires input or not. In this case, we don't need
		// any input
		$this->require_input = false;
		// Set this to 'false' if the item is unusable. This is good for display
		// items, such as rocks :).
		$this->can_use_item = true;
	}

	// Since this item requires no input, we don't need to have a getUseInput function
	// here (see the testitem2.php file if you want to make an item that needs input)


	// This is where all the fun begins. This function is called when 
	// the user actually uses the item. Return stuff, DON'T ECHO!
	function onUse() {
		return "Hello, I am a test!<br />This is all the test item does!!";
	}
}


?>
