<?php

/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: testitem.php
//      Test Item (gets some inputs, most likely you will base your items on this)

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: testitem2.php 24 2006-10-21 03:34:18Z daniel15 $

// Your class should always be called item_filename, eg. if your file is 
// myCoolItem.php then the class should be called 'item_myCoolItem'. This 
// class should always extend itemTemplate.

class item_testitem2 extends itemTemplate {
    
    // When this function is called, you should set all the item's
    // variables (see inside this example)
    function getItemDetails() {

		// The author's name
		$this->authorName = "Daniel15";
		// The author's email address
		$this->authorEmail = "dansoft@dansoftaustralia.net";

        //VALUES CHANGEABLE FROM WITHIN ADMIN PANEL:
          // The name of the item
          $this->name = "A Test Item 2";
          // The item's description
          $this->desc = "Just a test item! The second time!";
          // The item's price
          $this->price = 5;

        //UNCHANGABLE VALUES:
          // Whether inputs are required by this item. In this case, we get some inputs,
          // so set this to 'true'.
          $this->require_input = true;
          // Set this to 'false' if the item is unusable. This is good for display
          // items.
          $this->can_use_item = true;
    }

    // This function is called when the user tries to use the item.
    // If your item needs any further user input then you can get that 
    // input here (eg. if it's a "Change username" item then you have
    // to ask the user what they'd like to change their username to).
    // Any text you return will get shown to the user (DON'T ECHO STUFF).
    function getUseInput() {
        return "A Test: <input type='text' name='test123' />";
    }

    // This is where all the fun begins. This function is called when 
    // the user actually uses the item. Return stuff, DON'T ECHO!
    function onUse() {
        return "Hello, I am a test!<br />In the text box, you entered '{$_POST['test123']}'";
    }
}

?>
